<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

/*
* Uni_Cpo_Setting_Cpo_Mode_Radio class
*
*/

class Uni_Cpo_Setting_Cpo_Mode_Radio extends Uni_Cpo_Setting implements Uni_Cpo_Setting_Interface {

	/**
	 * Init
	 *
	 */
	public function __construct() {
		$this->setting_key  = 'cpo_mode_radio';
		if ( unicpo_fs()->is__premium_only() ) {
			$this->setting_data = array(
				'title'   => __( 'Type of radio input', 'uni-cpo' ),
				'options' => array(
					'classic' => __( 'Classic', 'uni-cpo' ),
					'image'   => __( 'Image', 'uni-cpo' ),
					'colour'  => __( 'Colour', 'uni-cpo' ),
					'text'    => __( 'Text', 'uni-cpo' ),
				),
				'js_var'  => 'data'
			);
		}
		if ( ! unicpo_fs()->is__premium_only() ) {
			$this->setting_data = array(
				'title'   => __( 'Type of radio input', 'uni-cpo' ),
				'options' => array(
					'classic' => __( 'Classic', 'uni-cpo' )
				),
				'js_var'  => 'data'
			);
		}
		add_action( 'wp_footer', array( $this, 'js_template' ), 10 );
	}

	/**
	 * A template for the module
	 *
	 * @since 1.0
	 * @return string
	 */
	public function js_template() {
		?>
        <script id="js-builderius-setting-<?php echo $this->setting_key; ?>-tmpl" type="text/template">
            <div class="uni-modal-row uni-clear">
				<?php echo $this->generate_field_label_html() ?>
                <div class="uni-modal-row-second uni-clear">
                    <div class="uni-setting-fields-wrap-2 uni-clear">
						<?php echo $this->generate_radio_html(); ?>
                    </div>
                </div>
            </div>
        </script>
		<?php
	}

}
